<template>
<div class="px-5 w-full">
  <div class="max-w-3xl w-full mx-auto">
    <div class="w-full flex">
      <form @submit.prevent="fetch" class="flex flex-grow w-full">
        <input v-model="url" placeholder="Paste a url" class="border border-black rounded-none px-3 h-10 w-60 inline-block flex-grow mr-3">
        <button class="border border-black rounded-none px-3 h-10 w-20 inline-block text-center bg-black text-white cursor-pointer hover:bg-gray-200 hover:text-black" @click="fetch">Fetch</button>
      </form>
    </div>
    <div class="py-8" v-show="isLoading">
      <Loader />
    </div>
    <div v-if="error" class="mt-5 bg-red-500 p-5 rounded text-white">
      Error: {{error}}
    </div>
    <div v-if="product && images.length" class="mt-5">
      <h3 class="text-sm font-bold uppercase">Result</h3>
      <div class="text-xs mt-2 bg-gray-100 border border-gray-400 rounded p-5 overflow-scroll max-h-80">
        <div class="flex">
            <a :href="url" target="_blank">
              <img
                :src="featuredImage"
                class="flex-none w-18 h-18 rounded-lg object-cover bg-gray-100 rounded mr-5"
                width="144"
                height="144"
              />
            </a>
            <div>
              <a :href="url" target="_blank">
                <h5 class="text-xl font-bold">{{product.name}}</h5>
                <div class="text-lg italic" v-if="product.brand">{{product.brand}}</div>
              </a>
              <div class="text-lg text-red-500">
                <div v-if="product.offers">
                  <span>{{variantPrice}} {{product.currency}}</span>
                  <select class="bg-transparent cursor-pointer inline-block text-black opacity-25" v-model="selectedVariant">
                    <option :value="null" default>(default)</option>
                    <option v-for="(offer, key) in product.offers" :key="key" :value="key">Variant {{key+1}}</option>
                  </select>
                </div>
                <a :href="url" target="_blank" v-else>
                  {{product.price}} {{product.currency}}
                </a>
              </div>
              <a :href="url" target="_blank">
                <div class="text-xs max-w-xs mt-1">{{product.description}}</div>
              </a>
            </div>
        </div>
      </div>
    </div>
    <div v-if="product && images.length" class="mt-5">
      <h3 class="text-sm font-bold uppercase">Images</h3>
      <div class="text-xs mt-2 bg-gray-100 border border-gray-400 rounded p-5 overflow-scroll max-h-90">
        <div class="grid grid-cols-4 gap-5">
        <img
          v-for="(image, key) in filteredImages"
          :key="key"
          :src="image"
          alt=""
          class="flex-none w-full rounded-lg object-cover bg-gray-100 rounded mr-5"
          width="100%"
          height="auto"
        />
        </div>
      </div>
    </div>
    <div v-if="data" class="mt-5">
      <h3 class="text-sm font-bold uppercase">Parsed</h3>
      <div class="text-xs mt-2 bg-gray-100 border border-gray-400 rounded p-5 overflow-scroll max-h-80">
        <pre>{{data.data}}</pre>
      </div>
    </div>
    <div v-if="data" class="mt-5">
      <h3 class="text-sm font-bold uppercase">Raw</h3>
      <div class="text-xs mt-2 bg-gray-100 border border-gray-400 rounded p-5 overflow-scroll max-h-80">
        <pre>{{data.raw}}</pre>
      </div>
    </div>
  </div>
</div>
</template>

<script>
const axios = require('axios')
import Loader from '~/components/Loader.vue'

export default {
  components: { Loader },
  data () {
    return {
      url: null,
      raw: null,
      data: null,
      error: null,
      isLoading: false,
      images: [],
      product: null,
      selectedVariant: null
    }
  },
  watch: {
    url () {
      this.reset()
    }
  },
  computed: {
    featuredImage () {
      return this.variant?.image ?? this.filteredImages[0]
    },
    variantPrice () {
      return this.variant?.price ?? (this.variant?.lowPrice ? (this.variant?.lowPrice === this.variant?.highPrice ? this.variant?.lowPrice : `${this.variant?.lowPrice} - ${this.variant?.highPrice}`) : this.product.price)
    },
    filteredImages () {
      const images = new Set(this.images)
      return [...images]
    },
    variant (){
      if(this.selectedVariant === null || this.selectedVariant == -1) return null
      else return this.product.offers[this.selectedVariant]
    },
  },
  methods: {
    reset () {
      this.images = []
      this.data = null
      this.product = null
    },
    validURL(str) {
        var pattern = new RegExp('^(https?:\\/\\/)?'+ // protocol
          '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|'+ // domain name
          '((\\d{1,3}\\.){3}\\d{1,3}))'+ // OR ip (v4) address
          '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*'+ // port and path
          '(\\?[;&a-z\\d%_.~+=-]*)?'+ // query string
          '(\\#[-a-z\\d_]*)?$','i'); // fragment locator
        return !!pattern.test(str);
    },
    checkImage(imageSrc, good, bad = () => {}) {
      var img = new Image();
      img.onload = good; 
      img.onerror = bad;
      img.src = imageSrc;
    },
    filterImages () {
      if (!this.data?.data?.images) return
      this.images = []
      this.isLoading = true
      this.counter = this.data.data.images.length
      this.data.data.images.forEach(image => {
        this.checkImage(image, () => {
          this.images.push(image)
          this.counter--
          if(!this.counter) this.isLoading = false
        }, () => {
          this.counter--
          if(!this.counter) this.isLoading = false
        })
      })
      const images = new Set(this.images)
      this.images = [...images]
    },
    fetch () {
      this.reset()
      this.error = null
      if (!this.validURL(this.url)) {
        this.error = 'Invalid URL!'
        return
      }
      this.isLoading = true
      try {
         axios.get(`/api/scrapper?url=${this.url}`).then(response => {
          this.data = response.data
          this.product = response.data.data
          this.filterImages()
          this.error = null
        }).catch(error => {
          this.error = error.message
        }).then(() => {
          this.isLoading = false
        })
      } catch(error) {
        this.error = error
        this.isLoading = false
      }
    }
  },
  mounted () {
    if(this.$route?.query?.url) {
      this.url = this.$route.query.url
      this.fetch()
    }
  }
}
</script>
